unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, DB, IBCustomDataSet, IBQuery, IBDatabase, ComObj,
  StdCtrls, IBSQL, IBStoredProc, Registry,StrUtils;

type
  TTransactionType = (ttReading, ttWriting, ttSnapShot, ttImport); //  

  TTransactionAction = (taStart, taCommit, taRollBack); //   

  TfrmMain = class(TForm)
    IBDatabase1: TIBDatabase;
    trReading: TIBTransaction;
    IBQuery1: TIBQuery;
    B_SelectFile: TButton;
    OpenDialog1: TOpenDialog;
    E_File: TEdit;
    Label1: TLabel;
    CB_naim: TComboBox;
    Label2: TLabel;
    CB_barcode: TComboBox;
    Label3: TLabel;
    CB_izm: TComboBox;
    Label4: TLabel;
    CB_warranty: TComboBox;
    Label6: TLabel;
    CB_SKU: TComboBox;
    Label7: TLabel;
    CB_Comment: TComboBox;
    CB_Spr_Izm: TComboBox;
    CB_Spr_Warranty: TComboBox;
    B_DelSprIzm: TButton;
    B_DelSprWarranty: TButton;
    B_IzmFromFile: TButton;
    B_WarrantyFromFile: TButton;
    LB_Izm: TListBox;
    LB_Warranty: TListBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    B_Preview: TButton;
    SG_preview: TStringGrid;
    B_Upload: TButton;
    B_Upload_EdIzm: TButton;
    B_Upload_Warranty: TButton;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    IBStoredProc1: TIBStoredProc;
    E_DB: TEdit;
    edPAss: TEdit;
    btnDBParam: TButton;
    trWriting: TIBTransaction;
    trSnapShot: TIBTransaction;
    IBQuery2: TIBQuery;
    procedure B_SelectFileClick(Sender: TObject);
    procedure B_IzmFromFileClick(Sender: TObject);
    procedure B_WarrantyFromFileClick(Sender: TObject);
    procedure B_PreviewClick(Sender: TObject);
    procedure B_UploadClick(Sender: TObject);
    procedure B_Upload_EdIzmClick(Sender: TObject);
    procedure B_Upload_WarrantyClick(Sender: TObject);
    procedure CB_izmChange(Sender: TObject);
    procedure btnDBParamClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CB_warrantyChange(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

    { ----- /   ----- }
function RunConnect(TypeTransaction: TTransactionType;
  TransactionAction: TTransactionAction): Boolean; //

{ -----    ----- }
function AppNotify(GDSCode: Integer; ErrText: string; Flags: Longint = MB_OK)
  : TModalResult;

var
  frmMain: TfrmMain;
  function BarcodeGen(vin_id:Integer):String;

implementation

{$R *.dfm}

   { ############################################################### }
  { ###               /                ### }
  { ############################################################### }
function RunConnect(TypeTransaction: TTransactionType;
  TransactionAction: TTransactionAction): Boolean;
var
//  CurrPanel: TAdvOfficeStatusPanel; // TAdvOfficeStatusBar;
  ImgNewIndex: ShortInt; //   
begin
  if frmMain.IBDatabase1.Connected then
    RESULT := True
  else
  begin
    RESULT := false;
    AppNotify(1, 'Database state is not connect', MB_ICONERROR + MB_OK);
//    frmMain.acLockUser.Execute;
    Exit;
  end;
//  CurrPanel := frmMain.StatusBar.Panels[3];
//  ImgNewIndex := CurrPanel.ImageIndex; //  ,  
  // -----   -----//
  case TypeTransaction of
    ttReading:
      // =====   ======//
      case TransactionAction of
        taStart: // 
          if (NOT frmMain.trReading.Active) then
          begin
            frmMain.trReading.StartTransaction; // 
//            ImgNewIndex := 1; // " "
//            inc(SummConnect[0]); //  ""
//            CurrPanel.OfficeHint.Title :=
//              (': ' + intToStr(SummConnect[0]));
//            inc(SummConnect[1]); //  ""
//            CurrPanel.OfficeHint.Notes[0] :=
//              (': ' + intToStr(SummConnect[1]));
          end;
        taCommit: // 
          begin
            if frmMain.trReading.Active then
              frmMain.trReading.Commit;
            ImgNewIndex := 0; // " ";
          end;
        taRollBack: //  
          begin
            frmMain.trReading.Active := false; //  
//            ImgNewIndex := 0; // " ";
//            inc(SummConnect[3]); //  ""
//            CurrPanel.OfficeHint.Notes[2] :=
//              (': ' + intToStr(SummConnect[3]));
          end;
      end;
    // ======   =====//
    ttWriting:
      case TransactionAction of
        taStart: // 
          if frmMain.trWriting.Active then
            // -----     ----//
            case AppNotify(4, 'Writing transaction is run',
              MB_ICONWARNING + MB_RETRYCANCEL) of
              mrRetry:
                if RunConnect(ttWriting, taStart) = false then
                  RESULT := false;
              mrCancel:
                RESULT := false;
            end
          else
          // ----     -  ----//
          begin
            frmMain.trWriting.StartTransaction; // 
//            ImgNewIndex := 2; // " "
//            inc(SummConnect[0]); //  ""
//            CurrPanel.OfficeHint.Title :=
//              (': ' + intToStr(SummConnect[0]));
//            inc(SummConnect[2]); //  ""
//            CurrPanel.OfficeHint.Notes[1] :=
//              (': ' + intToStr(SummConnect[2]));
          end;
        taCommit: // 
          begin
            frmMain.trWriting.Commit; // 
            if frmMain.trReading.Active then
              ImgNewIndex := 1 // " "
            else
              ImgNewIndex := 0; // " ";
          end;
        taRollBack: //  
          begin
            frmMain.trWriting.Rollback; // ,   
            if frmMain.trReading.Active then
              ImgNewIndex := 1 // " "
            else
              ImgNewIndex := 0; // " ";
//            inc(SummConnect[3]); //  ""
//            CurrPanel.OfficeHint.Notes[2] :=
//              (': ' + intToStr(SummConnect[3]));
          end
      end; // Case  TransactionAction
    // =====   ======//
    ttSnapShot:
      case TransactionAction of
        taStart: // 
          if (NOT frmMain.trSnapShot.Active) then
          begin
            frmMain.trSnapShot.StartTransaction; // 
            ImgNewIndex := 3; // " "
//            inc(SummConnect[0]); //  ""
//            CurrPanel.OfficeHint.Title :=
//              (': ' + intToStr(SummConnect[0]));
//            inc(SummConnect[1]); //  ""
//            CurrPanel.OfficeHint.Notes[0] :=
//              (': ' + intToStr(SummConnect[1]));
          end;
        taCommit: // 
          begin
            if frmMain.trSnapShot.Active then
              frmMain.trSnapShot.Commit;
            if frmMain.trReading.Active then
              ImgNewIndex := 1 // " "
            else
              ImgNewIndex := 0; // " ";
          end;
        taRollBack: //  
          begin
            frmMain.trSnapShot.Active := false; //  
            if frmMain.trReading.Active then
              ImgNewIndex := 1 // " "
            else
              ImgNewIndex := 0; // " ";
//            inc(SummConnect[3]); //  ""
//            CurrPanel.OfficeHint.Notes[2] :=
//              (': ' + intToStr(SummConnect[3]));
          end;
      end; // SnapShot Case
    ttImport:
      // =====   ======//
      case TransactionAction of
        taStart: // 
          if (NOT frmMain.trReading.Active) then
          begin
            frmMain.trReading.StartTransaction; // 
            ImgNewIndex := 1; // " "
//            inc(SummConnect[0]); //  ""
//            CurrPanel.OfficeHint.Title :=
//              (': ' + intToStr(SummConnect[0]));
//            inc(SummConnect[1]); //  ""
//            CurrPanel.OfficeHint.Notes[0] :=
//              (': ' + intToStr(SummConnect[1]));
          end;
        taCommit: // 
          begin
            if frmMain.trReading.Active then
              frmMain.trReading.Commit;
            ImgNewIndex := 0; // " ";
          end;
        taRollBack: //  
          begin
            frmMain.trReading.Active := false; //  
            ImgNewIndex := 0; // " ";
//            inc(SummConnect[3]); //  ""
//            CurrPanel.OfficeHint.Notes[2] :=
//              (': ' + intToStr(SummConnect[3]));
          end;
      end;
  end; // Typetransaction Case
//  CurrPanel.ImageIndex := ImgNewIndex;
end;

{ ############################################################### }
{ ###                                 ### }
{ ############################################################### }
function AppNotify(GDSCode: Integer; ErrText: string; Flags: Longint = MB_OK)
  : TModalResult;

  function DecryptExceptText(Where: string): string;
  var
    StartPos, EndPos: Integer;
  begin
    StartPos := PosEx('[[', Where, 1);
    EndPos := PosEx(']]', Where, StartPos);
    RESULT := Copy(Where, StartPos + 2, EndPos - StartPos - 2);
    // 2- Length('[[')
  end;

  function GetNumDBException(Where: string): Integer;
  var
    StartPos, EndPos: Integer;

  begin
    StartPos := PosEx('exception ', Where, 1);
    EndPos := PosEx(#13, Where, StartPos);
    RESULT := StrToIntdef(Copy(Where, StartPos + 10,
      EndPos - StartPos - 10), 0);
  end;

var
  MsgText, MsgCaption: string; //  
begin
  // -----    -----//
  case GDSCode of
    1: //    
      begin
        MsgCaption := ' ';
        MsgText := '   ';
        MsgText := MsgText + #13 + ErrText;
      end;

    2: //    
      begin
        MsgCaption := '  ';
        MsgText := '      .';
        MsgText := MsgText + #13 + ErrText;
      end;
    3: //    
      begin
        MsgCaption := '  ';
        MsgText := '      ';
        MsgText := MsgText + #13 + ErrText;
      end;
    4: //    
      begin
        MsgCaption := '  ';
        MsgText := '       ';
        MsgText := MsgText + #13 + ErrText;
      end;
    5: // :   "" 
      begin
        MsgCaption := '  ';
        MsgText := '   ';
        MsgText := MsgText + #13 + ErrText;
      end;
    6: //    
      begin
        MsgCaption := '   ';
        MsgText := '    ';
        MsgText := MsgText;
      end;
    7: //    
      begin
        MsgCaption := '  ';
        MsgText := '   ';
        MsgText := MsgText + #13 + ErrText;
      end;
    335544517: //    
      begin
        case GetNumDBException(ErrText) of
          0:
            begin
              MsgCaption := '  ';
              MsgText := ErrText;
            end;
          1: // ESTORE_LACKAMOUNT
            begin
              MsgCaption := ' ';
              MsgText := '     ' +
                DecryptExceptText(ErrText);
            end;
           2: // EDOCUMTITLES_ERRSTATEDOC
            begin
              MsgCaption := ' ';
              MsgText := '   ';
            end;
        end;
      end;
    // ======   ======//
  else
    begin
      MsgCaption := ' ';
      MsgText := 'Error: ' + intToStr(GDSCode) + #13 + ErrText;
    end;
  end;
  MsgText := MsgText;
  RESULT := MessageBox(frmMain.Handle, PWideChar(MsgText),
    PWideChar(MsgCaption), Flags);
end;

procedure TfrmMain.B_SelectFileClick(Sender: TObject);
var
 i:Integer;
 XL: Variant;
begin
 IF OpenDialog1.Execute THEN
  begin
   E_File.Text:=OpenDialog1.FileName;
   XL := CreateOLEObject('Excel.Application'); //  OLE 
   XL.WorkBooks.add;
   XL.WorkBooks.Open(E_file.Text);
   XL.Visible:=False;
  // XL.Rows[1].Delete;
   for i:=0 to frmMain.ComponentCount-1 do
    begin
     if (frmMain.Components[i] is TCombobox) then
      TCombobox(frmMain.Components[i]).Items.Clear;
    end;
   I:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     CB_naim.Items.Add(XL.Cells[1,i].Value);
     CB_barcode.Items.Add(XL.Cells[1,i].Value);
     CB_izm.Items.Add(XL.Cells[1,i].Value);
     CB_warranty.Items.Add(XL.Cells[1,i].Value);
     CB_SKU.Items.Add(XL.Cells[1,i].Value);
     CB_Comment.Items.Add(XL.Cells[1,i].Value);
     i:=i+1;
    end;
   CB_barcode.Items.Add(' ');
   CB_izm.Items.Add(' ');
   CB_warranty.Items.Add(' ');
   CB_SKU.Items.Add(' ');
   CB_Comment.Items.Add(' ');
   XL.DisplayAlerts:= False;
   XL.Workbooks.Close;
   XL.DisplayAlerts:= True;
   XL.Application.quit;
   XL := Unassigned;
   CB_barcode.ItemIndex:=CB_barcode.Items.Count-1;
   CB_izm.ItemIndex:=CB_izm.Items.Count-1;
   CB_warranty.ItemIndex:=CB_warranty.Items.Count-1;
   CB_SKU.ItemIndex:=CB_SKU.Items.Count-1;
   CB_Comment.ItemIndex:=CB_Comment.Items.Count-1;
   CB_Spr_Izm.Items.Clear;
   //IBTransaction1.Active:=False;
//   IBTransaction1.Active:=True;
   if RunConnect(ttReading, taStart) = False then
    Exit;
  //   
   try
    begin
     IBQuery2.Close;
     IBQuery2.SQL.Clear;
     IBQuery2.SQL.Add('select FUNITNAME from TUNITS');
     IBQuery2.Open;
     if IBQuery2.RecordCount>0 then
      while not(IBQuery2.Eof) do
       begin
        CB_Spr_Izm.Items.Add(IBQuery2.Fields[0].AsString);
        IBQuery2.Next;
       end;
    end;
   except
    // -----      -----//
    on E: exception do
    begin
      RunConnect(ttReading, taRollBack);
      AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
    end;
   end;
   //IBTransaction1.Active:=False;
   //IBTransaction1.Active:=True;
   CB_Spr_Warranty.Items.Clear;
   if RunConnect(ttReading, taStart) = False then
    Exit;
  //   
   try
    begin
     IBQuery2.Close;
     IBQuery2.SQL.Clear;
     IBQuery2.SQL.Add('select FWARRANTYNAME from TWARRANTY');
     IBQuery2.Open;
     if IBQuery2.RecordCount>0 then
      while not(IBQuery2.Eof) do
       begin
        CB_Spr_Warranty.Items.Add(IBQuery2.Fields[0].AsString);
        IBQuery2.Next;
       end;
    end;
   except
    // -----      -----//
    on E: exception do
    begin
      RunConnect(ttReading, taRollBack);
      AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
    end;
   end;
   //IBTransaction1.Active:=False;
   CB_Spr_Izm.ItemIndex:=CB_Spr_Izm.Items.Count-1;
   CB_Spr_Warranty.ItemIndex:=CB_Spr_Warranty.Items.Count-1;
  end;
end;



procedure TfrmMain.btnDBParamClick(Sender: TObject);
begin
 IBDatabase1.Close;
 IBDatabase1.DatabaseName:=E_DB.Text;
 IBDatabase1.Params.Clear;
 IBDatabase1.Params.Add('user_name=SYSDBA');
 IBDatabase1.Params.Add('password='+edPass.Text);
 IBDatabase1.Open;
end;

procedure TfrmMain.B_IzmFromFileClick(Sender: TObject);
var
 a,b,f:String;
 j,i:Integer;
 XL: Variant;
begin
 XL := CreateOLEObject('Excel.Application'); //  OLE 
 XL.WorkBooks.add;
 XL.WorkBooks.Open(E_file.Text);
 XL.Visible:=False;
 // XL.Rows[1].Delete;
 LB_Izm.Items.Clear;
 CB_Spr_Izm.Items.Clear;
 I:=1;
 CB_naim.Tag:=-1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   a:=CB_naim.Items.Strings[CB_naim.ItemIndex];
   b:=XL.Cells[1,i].Value;
   if a=b then
    CB_naim.Tag:=i;
   i:=i+1;
  end;
 CB_izm.Tag:=-1;
 i:=1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_izm.Items.Strings[CB_izm.ItemIndex]=XL.Cells[1,i].Value then
    CB_izm.Tag:=i;
   i:=i+1;
  end;
 I:=2;
 if ((CB_izm.Tag>0)and(CB_naim.Tag>0)) then
  while not VarIsEmpty(XL.Cells[i,CB_naim.Tag].Value) do
   begin
    LB_Izm.ItemIndex:=-1;
    f:='';
    for j:=0 to LB_Izm.Items.Count-1 do
     begin
      LB_Izm.ItemIndex:=j;
      if ((LB_Izm.Items.Strings[LB_Izm.ItemIndex]=XL.Cells[i,CB_izm.Tag].Value)or(varisempty(XL.Cells[i,CB_Izm.Tag].Value))) then
       f:='';
     end;
    if F='' then
     begin
      LB_Izm.Items.Add(XL.Cells[i,CB_izm.Tag].Value);
      CB_Spr_izm.Items.Add(XL.Cells[i,CB_izm.Tag].Value);
     end;
    i:=i+1;
   end;
 XL.DisplayAlerts:= False;
 XL.Workbooks.Close;
 XL.DisplayAlerts:= True;
 XL.Application.quit;
 XL := Unassigned;
end;

procedure TfrmMain.B_WarrantyFromFileClick(Sender: TObject);
var
 a,b,f:String;
 j,i:Integer;
 XL: Variant;
begin
 XL := CreateOLEObject('Excel.Application'); //  OLE 
 XL.WorkBooks.add;
 XL.WorkBooks.Open(E_file.Text);
 XL.Visible:=False;
 // XL.Rows[1].Delete;
 LB_warranty.Items.Clear;
 CB_SPr_warranty.Items.Clear;
 I:=1;
 CB_naim.Tag:=-1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   a:=CB_naim.Items.Strings[CB_naim.ItemIndex];
   b:=XL.Cells[1,i].Value;
   if a=b then
    CB_naim.Tag:=i;
   i:=i+1;
  end;
 CB_warranty.Tag:=-1;
 i:=1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_warranty.Items.Strings[CB_warranty.ItemIndex]=XL.Cells[1,i].Value then
    CB_warranty.Tag:=i;
   i:=i+1;
  end;
 I:=2;
 if ((CB_warranty.Tag>0)and(CB_naim.Tag>0)) then
  while not VarIsEmpty(XL.Cells[i,CB_naim.Tag].Value) do
   begin
    LB_warranty.ItemIndex:=-1;
    f:='';
    for j:=0 to LB_warranty.Items.Count-1 do
     begin
      LB_warranty.ItemIndex:=j;
      if ((LB_warranty.Items.Strings[LB_warranty.ItemIndex]=XL.Cells[i,CB_warranty.Tag].Value)or(varisempty(XL.Cells[i,CB_warranty.Tag].Value))) then
       f:='';
     end;
    if F='' then
     begin
      LB_warranty.Items.Add(XL.Cells[i,CB_warranty.Tag].Value);
      CB_Spr_warranty.Items.Add(XL.Cells[i,CB_warranty.Tag].Value);
     end;
    i:=i+1;
   end;
 XL.DisplayAlerts:= False;
 XL.Workbooks.Close;
 XL.DisplayAlerts:= True;
 XL.Application.quit;
 XL := Unassigned;
end;

procedure TfrmMain.B_PreviewClick(Sender: TObject);
var
 a,b:String;
 j,i:Integer;
 XL: Variant;
begin
 if CB_warranty.ItemIndex=-1 then
  begin
   ShowMessage('    -.         ');
   exit;
  end;
 for i:=0 to 10 do
  for j:=1 to 10 do
   SG_preview.Cells[i,j]:='';
 SG_preview.Cells[0,0]:='';
 SG_preview.Cells[1,0]:='';
 SG_preview.Cells[2,0]:='. ';
 SG_preview.Cells[3,0]:='';
 SG_preview.Cells[4,0]:='';
 SG_preview.Cells[5,0]:='';
 XL := CreateOLEObject('Excel.Application'); //  OLE 
 XL.WorkBooks.add;
 XL.WorkBooks.Open(E_file.Text);
 XL.Visible:=fALSE;
 // XL.Rows[1].Delete;
 CB_naim.Tag:=-1;
 i:=1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_naim.Items.Strings[CB_naim.ItemIndex]=XL.Cells[1,i].Value then
    CB_naim.Tag:=i;
   i:=i+1;
  end;
 CB_warranty.Tag:=-1;
 if CB_warranty.Items.Strings[CB_warranty.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_warranty.Items.Strings[CB_warranty.ItemIndex]=XL.Cells[1,i].Value then
      CB_warranty.Tag:=i;
     i:=i+1;
    end;
  end
 else
  begin
   CB_warranty.Tag:=0;
  end; 
 CB_barcode.Tag:=-1;
 if CB_barcode.Items.Strings[CB_barcode.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_barcode.Items.Strings[CB_barcode.ItemIndex]=XL.Cells[1,i].Value then
      CB_barcode.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_barcode.Tag:=0;
 CB_izm.Tag:=-1;
 if CB_izm.Items.Strings[CB_izm.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_izm.Items.Strings[CB_izm.ItemIndex]=XL.Cells[1,i].Value then
      CB_izm.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_izm.Tag:=0;
 CB_SKU.Tag:=-1;
 if CB_SKU.Items.Strings[CB_SKU.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_SKU.Items.Strings[CB_SKU.ItemIndex]=XL.Cells[1,i].Value then
      CB_SKU.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_SKU.Tag:=0;
 CB_comment.Tag:=-1;
 if CB_comment.Items.Strings[CB_comment.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_comment.Items.Strings[CB_comment.ItemIndex]=XL.Cells[1,i].Value then
      CB_comment.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_comment.Tag:=0;
 I:=1;
 if CB_naim.Tag>0 then
  while ((not VarIsEmpty(XL.Cells[i,CB_naim.Tag].Value))and(i<7)) do
   begin
    SG_preview.Cells[0,i]:=XL.Cells[i+1,CB_naim.Tag].Value;
    if CB_barcode.Tag>0 then
     SG_preview.Cells[1,i]:=XL.Cells[i+1,CB_barcode.Tag].Value
    else
     SG_preview.Cells[1,i]:='';
    if CB_izm.Tag<>0 then
     if (VarIsEmpty((XL.Cells[i+1,CB_izm.Tag].Value)) or (CB_izm.Items.Strings[CB_izm.ItemIndex]=' ')) then
      SG_preview.Cells[2,i]:=CB_Spr_Izm.Items.Strings[CB_Spr_Izm.Itemindex]
     else
      SG_preview.Cells[2,i]:=XL.Cells[i+1,CB_izm.Tag].Value;
    if CB_warranty.Tag<>0 then
     if ((VarIsEmpty(XL.Cells[i+1,CB_warranty.Tag].Value)) or (CB_warranty.Items.Strings[CB_warranty.ItemIndex]=' ')) then
      SG_preview.Cells[3,i]:=CB_Spr_Warranty.Items.Strings[CB_Spr_warranty.Itemindex]
     else
      SG_preview.Cells[3,i]:=XL.Cells[i+1,CB_warranty.Tag].Value;
    if CB_SKU.Tag<>0 then
     if CB_sku.Tag>0 then
      SG_preview.Cells[4,i]:=XL.Cells[i+1,CB_sku.Tag].Value;
    if CB_Comment.Tag<>0 then
     if CB_comment.Tag>0 then
      SG_preview.Cells[5,i]:=XL.Cells[i+1,CB_comment.Tag].Value;
    i:=i+1;
   end
 else
  ShowMessage('     ');
 XL.DisplayAlerts:= False;
 XL.Workbooks.Close;
 XL.DisplayAlerts:= True;
 XL.Application.quit;
 XL := Unassigned;
end;

procedure TfrmMain.B_UploadClick(Sender: TObject);
var
 izmid,warid,maxid,i:Integer;
 XL: Variant;
 naim,sku,comment,barcod,per,per2,q:String;
begin
 if RunConnect(ttReading, taStart) = False then
    Exit;
  //   
  try
   begin
    IBQuery2.SQL.Clear;
    IBQuery2.SQL.Add('SELECT GEN_ID(GEN_TGOODS_ID, 1) FROM RDB$DATABASE');
    IBQuery2.Open;
    maxid:=IBQuery2.Fields[0].AsInteger;
    RunConnect(ttReading,taCommit);
    end;
  except
    // -----      -----//
    on E: exception do
    begin
      RunConnect(ttReading, taRollBack);
      AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
    end;
  end;
 XL := CreateOLEObject('Excel.Application'); //  OLE 
 XL.WorkBooks.add;
 XL.WorkBooks.Open(E_file.Text);
 XL.Visible:=fALSE;
 // XL.Rows[1].Delete;
 CB_naim.Tag:=-1;
 i:=1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_naim.Items.Strings[CB_naim.ItemIndex]=XL.Cells[1,i].Value then
    CB_naim.Tag:=i;
   i:=i+1;
  end;
 CB_warranty.Tag:=-1;
 if CB_warranty.Items.Strings[CB_warranty.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_warranty.Items.Strings[CB_warranty.ItemIndex]=XL.Cells[1,i].Value then
      CB_warranty.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_warranty.Tag:=0;
 CB_barcode.Tag:=-1;
 if CB_barcode.Items.Strings[CB_barcode.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_barcode.Items.Strings[CB_barcode.ItemIndex]=XL.Cells[1,i].Value then
      CB_barcode.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_barcode.Tag:=0;
 CB_izm.Tag:=-1;
 if CB_izm.Items.Strings[CB_izm.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_izm.Items.Strings[CB_izm.ItemIndex]=XL.Cells[1,i].Value then
      CB_izm.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_izm.Tag:=0;
 CB_SKU.Tag:=-1;
 if CB_SKU.Items.Strings[CB_SKU.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_SKU.Items.Strings[CB_SKU.ItemIndex]=XL.Cells[1,i].Value then
      CB_SKU.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_SKU.Tag:=0;
 CB_comment.Tag:=-1;
 if CB_comment.Items.Strings[CB_comment.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_comment.Items.Strings[CB_comment.ItemIndex]=XL.Cells[1,i].Value then
      CB_comment.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_comment.Tag:=0;
 i:=2;
 IBQuery2.Close;
 if CB_naim.Tag>0 then
  begin
   while not VarIsEmpty(XL.Cells[i,CB_naim.Tag].Value) do
    begin
     if CB_izm.Tag>0 then
      if VarIsEmpty(XL.Cells[i,CB_izm.Tag].Value) then
       per:=CB_Spr_Izm.Items.Strings[CB_Spr_Izm.ItemIndex]
      else
       per:=XL.Cells[i,CB_izm.Tag].Value
     else
      per:=CB_Spr_Izm.Items.Strings[CB_Spr_Izm.ItemIndex];
     //IBTransaction1.Active:=False;
     //IBTransaction1.Active:=True;
     if RunConnect(ttReading, taStart) = False then
      Exit;
  //   
     try
       begin
        IBQuery2.SQL.Clear;
        q:='select FID from TUNITS where FUNITNAME='+QuotedStr(per);
        IBQuery2.SQL.Add(q);
        IBQuery2.Open;
        if IBQuery2.RecordCount>0 then
         izmid:=IBQuery2.Fields[0].AsInteger;
        IBQuery2.Close;
        RunConnect(ttReading,taCommit);
      end;
     except
      // -----      -----//
       on E: exception do
       begin
         RunConnect(ttReading, taRollBack);
         AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
       end;
     end;
     //IBTransaction1.Active:=False;
     //warranty
     if CB_warranty.Tag>0 then
      if varisempty(XL.Cells[i,CB_warranty.Tag].Value) then
       per2:=CB_Spr_warranty.Items.Strings[CB_Spr_warranty.ItemIndex]
      else
       per2:=XL.Cells[i,CB_warranty.Tag].Value
     else
      per2:=CB_Spr_warranty.Items.Strings[CB_Spr_warranty.ItemIndex];
     //IBTransaction1.Active:=False;
     //IBTransaction1.Active:=True;
     if RunConnect(ttReading, taStart) = False then
      Exit;
  //   
     try
       begin
        IBQuery2.SQL.Clear;
        q:='select FID from TWARRANTY where FWARRANTYNAME='+QuotedStr(per2);
        IBQuery2.SQL.Add(q);
        IBQuery2.Open;
        if IBQuery2.RecordCount>0 then
         warid:=IBQuery2.Fields[0].AsInteger;
        IBQuery2.Close;
        RunConnect(ttReading,taCommit);
      end;
     except
      // -----      -----//
       on E: exception do
       begin
         RunConnect(ttReading, taRollBack);
         AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
       end;
     end;
     //IBTransaction1.Active:=False;
     if CB_barcode.Tag>0 then
      barcod:=XL.Cells[i,CB_barcode.Tag].Value
     else
      barcod:=BarcodeGen(maxid);
     if CB_sku.Tag>0 then
      sku:=XL.Cells[i,CB_sku.Tag].Value
     else
      sku:='';
     if CB_comment.Tag>0 then
      comment:=XL.Cells[i,CB_comment.Tag].Value
     else
      comment:='';
     //IBTransaction1.Active:=False;
     //IBTransaction1.Active:=True;
     //
     //  
     naim:=XL.Cells[i,CB_naim.Tag].Value;
     if length(naim)>250 then
      naim:=Copy(XL.Cells[i,CB_naim.Tag].Value,0,250);
     if length(sku)>30 then
      sku:=Copy(sku,0,30);
     if length(comment)>150 then
      sku:=Copy(comment,0,150);
    //
     if RunConnect(ttWriting, taStart) = False then
      Exit;
  //   
     try
       begin
        IBQuery1.SQL.Clear;
        q:='insert into TGOODS (FID, FGOODSNAME, FBARCODE, FUNIT, '+
        'FWARRANTY, FARTICLE, FCOMMENT, FPRINT) values';
        q:=q+' ('+IntToStr(maxid)+','+QuotedStr(XL.Cells[i,CB_naim.Tag].Value);
        q:=q+','+QuotedStr(barcod);
     // ','+XL.Cells[i+1,CB_izm.Tag].Value+
        q:=q+','+IntToStr(izmid);
    // ','+XL.Cells[i+1,CB_warranty.Tag].Value+
        q:=q+','+IntToStr(warid);
        q:=q+','+QuotedStr(sku);
        q:=q+','+QuotedStr(comment)+',1)';
        IBQuery1.SQL.Add(q);
        IBQuery1.Open;
        RunConnect(ttWriting,taCommit);
       end;
     except
      // -----      -----//
       on E: exception do
       begin
         RunConnect(ttReading, taRollBack);
         AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
       end;
     end;
     //IBTransaction1.Commit;
     i:=i+1;
     IBQuery2.Close;
     IBQuery2.SQL.Clear;
//    SELECT GEN_ID(GEN_TGOODS_ID, 1) FROM RDB$DATABASE
     IBQuery2.SQL.Add('SELECT GEN_ID(GEN_TGOODS_ID, 1) FROM RDB$DATABASE');
     IBQuery2.Open;
     maxid:=maxid+1;
    end;
   ShowMessage(' ');
  end
 else
  ShowMessage('    ');  
 XL.DisplayAlerts:= False;
 XL.Workbooks.Close;
 XL.DisplayAlerts:= True;
 XL.Application.quit;
 XL := Unassigned;
end;

procedure TfrmMain.B_Upload_EdIzmClick(Sender: TObject);
var
 maxid,i:Integer;
 XL: Variant;
 q:String;
begin
 //IBTransaction1.Active:=False;
 //IBTransaction1.Active:=True;
 if RunConnect(ttReading, taStart) = False then
    Exit;
  //   
 try
   begin
    IBQuery2.SQL.Clear;
//    SELECT GEN_ID(GEN_TUNITS_ID, 1) FROM RDB$DATABASE
    IBQuery2.SQL.Add('SELECT GEN_ID(GEN_TUNITS_ID, 1) FROM RDB$DATABASE');
    IBQuery2.Open;
    if IBQuery2.RecordCount>0 then
     maxid:=IBQuery2.Fields[0].AsInteger
    else
     maxid:=1;
    //MAXID:=MAXID+1;
    IBQuery2.Close;
    RunConnect(ttReading,taCommit);
   end;
 except
  // -----      -----//
    on E: exception do
     begin
      RunConnect(ttReading, taRollBack);
      AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
    end;
 end;
 //IBTransaction1.Active:=False;
 XL := CreateOLEObject('Excel.Application'); //  OLE 
 XL.WorkBooks.add;
 XL.WorkBooks.Open(E_file.Text);
 XL.Visible:=fALSE;
 I:=1;
 CB_naim.Tag:=-1;
 i:=1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_naim.Items.Strings[CB_naim.ItemIndex]=XL.Cells[1,i].Value then
    CB_naim.Tag:=i;
   i:=i+1;
  end;
 CB_warranty.Tag:=-1;
 if CB_warranty.Items.Strings[CB_warranty.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_warranty.Items.Strings[CB_warranty.ItemIndex]=XL.Cells[1,i].Value then
      CB_warranty.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_warranty.Tag:=0;
 CB_barcode.Tag:=-1;
 if CB_barcode.Items.Strings[CB_barcode.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_barcode.Items.Strings[CB_barcode.ItemIndex]=XL.Cells[1,i].Value then
      CB_barcode.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_barcode.Tag:=0;
 CB_izm.Tag:=-1;
 if CB_izm.Items.Strings[CB_izm.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_izm.Items.Strings[CB_izm.ItemIndex]=XL.Cells[1,i].Value then
      CB_izm.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_izm.Tag:=0;
 CB_SKU.Tag:=-1;
 if CB_SKU.Items.Strings[CB_SKU.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_SKU.Items.Strings[CB_SKU.ItemIndex]=XL.Cells[1,i].Value then
      CB_SKU.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_SKU.Tag:=0;
 CB_comment.Tag:=-1;
 if CB_comment.Items.Strings[CB_comment.ItemIndex]<>' ' then
  begin
   i:=1;
   while not VarIsEmpty(XL.Cells[1,I].Value) do
    begin
     Application.ProcessMessages;
     if CB_comment.Items.Strings[CB_comment.ItemIndex]=XL.Cells[1,i].Value then
      CB_comment.Tag:=i;
     i:=i+1;
    end;
  end
 else
  CB_comment.Tag:=0; 
 // XL.Rows[1].Delete;
 i:=2;
 while not VarIsEmpty(XL.Cells[i,CB_naim.Tag].Value) do
  begin
   if not VarIsEmpty(XL.Cells[i,CB_izm.Tag].Value) then
    begin
     if RunConnect(ttReading, taStart) = False then
       Exit;
  //   
     try
      begin
       IBQuery2.SQL.Clear;
       q:='select COUNT(FID) from TUNITS where FUNITNAME='+QuotedStr(XL.Cells[i,CB_izm.Tag].Value);
       IBQuery2.SQL.Add(q);
       IBQuery2.Open;
       if IBQuery2.RecordCount>0 then
        if IBQuery2.Fields[0].AsInteger<1 then
         begin
        //IBTransaction2.Active:=False;
        //IBTransaction2.Active:=True;
         if RunConnect(ttWriting, taStart) = False then
          Exit;
  //   
         try
          begin
           IBQuery1.SQL.Clear;
           q:='insert into TUNITS (FID, FUNITNAME) values';
           q:=q+' ('+IntToStr(maxid)+','+QuotedStr(XL.Cells[i,CB_izm.Tag].Value)+')';
           IBQuery1.SQL.Add(q);
           IBQuery1.Open;
           RunConnect(ttWriting,taCommit);
          end;
         except
  // -----      -----//
           on E: exception do
            begin
             RunConnect(ttWriting, taRollBack);
             AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
            end;
         end;
        //IBTransaction2.Commit;
        IBQuery2.SQL.Clear;
        IBQuery2.SQL.Add('SELECT GEN_ID(GEN_TUNITS_ID, 1) FROM RDB$DATABASE');
        IBQuery2.Open;
     //   maxid:=maxid+1;
       end;
       IBQuery2.Close;
       RunConnect(ttReading,taCommit);
      end;
      except
  // -----      -----//
       on E: exception do
        begin
         RunConnect(ttReading, taRollBack);
         AppNotify(2, E.Message, MB_ICONERROR + MB_OK); // 2-  
        end;
       end;
    end;
   i:=i+1;
  end;
 XL.DisplayAlerts:= False;
 XL.Workbooks.Close;
 XL.DisplayAlerts:= True;
 XL.Application.quit;
 XL := Unassigned;
end;

procedure TfrmMain.B_Upload_WarrantyClick(Sender: TObject);
var
 maxid,i:Integer;
 XL: Variant;
 q:String;
begin
 //IBTransaction1.Active:=False;
 //IBTransaction1.Active:=True;
 IBQuery2.SQL.Clear;
// SELECT GEN_ID(GEN_TWARRANTY_ID, 1) FROM RDB$DATABASE
 IBQuery2.SQL.Add('SELECT GEN_ID(GEN_TWARRANTY_ID, 1) FROM RDB$DATABASE');
 IBQuery2.Open;
 if IBQuery2.RecordCount>0 then
  maxid:=IBQuery2.Fields[0].AsInteger
 else
  maxid:=1;
// MAXID:=MAXID+1;
 IBQuery2.Close;
 //IBTransaction1.Active:=False;
 XL := CreateOLEObject('Excel.Application'); //  OLE 
 XL.WorkBooks.add;
 XL.WorkBooks.Open(E_file.Text);
 XL.Visible:=False;
 I:=1;
 CB_naim.Tag:=-1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_naim.Items.Strings[CB_naim.ItemIndex]=XL.Cells[1,i].Value then
    CB_naim.Tag:=i;
   i:=i+1;
  end;
 CB_Warranty.Tag:=-1;
 i:=1;
 while not VarIsEmpty(XL.Cells[1,I].Value) do
  begin
   Application.ProcessMessages;
   if CB_Warranty.Items.Strings[CB_Warranty.ItemIndex]=XL.Cells[1,i].Value then
    CB_Warranty.Tag:=i;
   i:=i+1;
  end;
 // XL.Rows[1].Delete;
 i:=2;
 while not VarIsEmpty(XL.Cells[i,CB_naim.Tag].Value) do
  begin
   if not VarIsEmpty(XL.Cells[i,CB_Warranty.Tag].Value) then
    begin
     IBQuery2.SQL.Clear;
     q:='select COUNT(FID) from TWARRANTY where FWARRANTYNAME='+QuotedStr(XL.Cells[i,CB_Warranty.Tag].Value);
     IBQuery2.SQL.Add(q);
     IBQuery2.Open;
     if IBQuery2.RecordCount>0 then
      if IBQuery2.Fields[0].AsInteger<1 then
       begin
        IBQuery1.SQL.Clear;
        q:='insert into TWARRANTY (FID, FWARRANTYNAME) values';
        q:=q+' ('+IntToStr(maxid)+','+QuotedStr(XL.Cells[i,CB_Warranty.Tag].Value)+')';
        IBQuery1.SQL.Add(q);
        IBQuery1.Open;
        //IBTransaction1.Commit;
        IBQuery2.SQL.Clear;
        // SELECT GEN_ID(GEN_TWARRANTY_ID, 1) FROM RDB$DATABASE
        IBQuery2.SQL.Add('SELECT GEN_ID(GEN_TWARRANTY_ID, 1) FROM RDB$DATABASE');
        IBQuery2.Open;
        maxid:=maxid+1;
       end;
     IBQuery2.Close;
    // IBTransaction1.Active:=False;
    // IBTransaction1.Active:=True;
    end;
   i:=i+1;
  end;
 XL.DisplayAlerts:= False;
 XL.Workbooks.Close;
 XL.DisplayAlerts:= True;
 XL.Application.quit;
 XL := Unassigned;
end;

procedure TfrmMain.CB_izmChange(Sender: TObject);
begin
 if CB_izm.Items.Strings[CB_Izm.ItemIndex]=' ' then
  begin
   GroupBox1.Visible:=False;
   if GroupBox2.Visible=False then
    Label10.Visible:=False;
  end
 else
  begin
   GroupBox1.Visible:=True;
   Label10.Visible:=True;
  end;
end;

procedure TfrmMain.CB_warrantyChange(Sender: TObject);
begin
 if CB_warranty.Items.Strings[CB_warranty.ItemIndex]=' ' then
  begin
   GroupBox2.Visible:=False;
   if GroupBox1.Visible=False then
    Label10.Visible:=False;
  end
 else
  begin
   GroupBox2.Visible:=True;
   Label10.Visible:=True;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
 Reg: tRegistry;
begin
 // ------   ------//
 Reg := tRegistry.Create(KEY_READ); //  
  if Reg.KeyExists('Software\OPSURT\OPSURTv2\Connect') then
    // ----   -----//
    // try
   begin
    Reg.OpenKey('Software\OPSURT\OPSURTv2\Connect', True);
    E_DB.Text:=Reg.ReadString('Host');
    E_DB.Text:=E_DB.Text+':'+Reg.ReadString('Path');
    if Reg.ReadString('Port')<>'' then
     E_DB.Text:=E_DB.Text+':'+Reg.ReadString('Port')
   end;
 Reg.CloseKey;
end;

function BarcodeGen(vin_id:Integer):String;
begin
 frmMain.IBStoredProc1.ParamByName('PREFIX').Value:=2;
 frmMain.IBStoredProc1.ParamByName('VIN_ID').Value:=vin_id;
 frmMain.IBStoredProc1.Prepare;
 frmMain.IBStoredProc1.ExecProc;
 Result:=frmMain.IBStoredProc1.ParamByName('BARCODE').Value;
end;

end.
